﻿Module modWW
    Const strSJIS As String = "Shift_JIS"
    Enum enm項目
        ソート
        番号
        状態
        ファイル名
        パス
        ビット
        チャンネル数
        排他再生
        ループ再生
        音量
        パン
        周波数
        優先度
        WAVE位置
        WAVEサイズ
        ファイル名位置
        ファイル名長さ
        パス位置
        パス長さ
        WAVE新位置
        WLK
    End Enum
    Enum enmWAV
        CNL_POS = 22    'チャンネル（ステレオ／モノラル）
        SMP_POS = 24    '標本化周波数／サンプリング周波数／サンプリングレート
        SPD_POS = 28
        BIT_POS = 34    '量子化ビット数
        DAT_POS = 44
        LEN_POS = 40
        SIZ_POS = 4
    End Enum
    <System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Structure WAVEHDR
        Dim lpData As Integer
        Dim dwBufferLength As Integer
        Dim dwBytesRecorded As Integer
        Dim dwUser As Integer
        Dim dwFlags As Integer
        Dim dwLoops As Integer
        Dim lpNext As Integer
        Dim Reserved As Integer
    End Structure
    <System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Structure WAVEFORMATEX
        Dim wFormatTag As Short
        Dim nChannels As Short
        Dim nSamplesPerSec As Integer
        Dim nAvgBytesPerSec As Integer
        Dim nBlockAlign As Short
        Dim wBitsPerSample As Short
        Dim cbSize As Short
    End Structure
    Dim WAV_HDR As WAVEHDR
    Dim WAV_FMT As WAVEFORMATEX
    Public Const strNAME As String = "WAV2WLK2"
    Public strパス As String
    Sub File_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        Dim FilePath() As String

        FilePath = CType(e.Data.GetData(DataFormats.FileDrop), String())
        If FilePath.Length - 1 < 0 Then Return
        sender.Text = FilePath(0)
    End Sub
    Sub File_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs, Optional ByVal bolFILE As Boolean = True)
        Dim FilePath() As String

        If e.Data.GetDataPresent(DataFormats.FileDrop) = False Then Return
        FilePath = CType(e.Data.GetData(DataFormats.FileDrop), String())

        If FilePath.Length - 1 < 0 Then Return
        If bolFILE Then
            If Not System.IO.File.Exists(FilePath(0)) Then Return
        Else
            If Not System.IO.Directory.Exists(FilePath(0)) Then Return
        End If

        e.Effect = DragDropEffects.Copy
    End Sub
    Function FILE_DLG(ByVal wform As Form, ByRef strBUF As String, strFIL As String, ByVal bolOPN As Boolean) As Boolean
        Dim dlgOPN As FileDialog
        Dim bolOK As Boolean
        Dim strFLE As String = ""
        Dim strNAM As String = ""
        Static strDIR As String = ""

        If bolOPN Then
            dlgOPN = New OpenFileDialog()
        Else
            dlgOPN = New SaveFileDialog()
        End If
        dlgOPN.Filter = strFIL
        dlgOPN.Title = "ファイル名を指定して下さい"
        If strDIR <> "" Then
            dlgOPN.InitialDirectory = strDIR
        Else
            dlgOPN.InitialDirectory = strパス
        End If
        If dlgOPN.ShowDialog() = DialogResult.OK Then
            strFLE = dlgOPN.FileName
            bolOK = True
        End If
        dlgOPN.Dispose()
        If bolOK Then
            strBUF = strFLE
            strDIR = System.IO.Path.GetDirectoryName(strFLE)
        End If

        Return bolOK
    End Function
    Function DIR_DLG(ByVal wform As Form, ByRef bytBUF As String) As Boolean
        Dim dlgOPN As New FolderBrowserDialog
        Dim bolOK As Boolean
        Dim strBUF As String = ""
        Dim strNAM As String = ""
        Static strDIR As String = ""

        dlgOPN.Description = "フォルダを指定して下さい"
        dlgOPN.RootFolder = Environment.SpecialFolder.Desktop
        If strDIR <> "" Then
            dlgOPN.SelectedPath = strDIR
        Else
            dlgOPN.SelectedPath = strパス
        End If
        If dlgOPN.ShowDialog() = DialogResult.OK Then
            strDIR = dlgOPN.SelectedPath
            bolOK = True
        End If
        dlgOPN.Dispose()
        If bolOK Then bytBUF = strDIR

        Return bolOK
    End Function
    Function バイナリ読込(ByVal strNAM As String, ByRef bytBUF() As Byte) As Boolean
        Dim objFS As System.IO.FileStream
        Dim lngIDX As Long
        Dim lngMAX As Long
        Try
            objFS = New System.IO.FileStream(strNAM, IO.FileMode.Open, IO.FileAccess.Read)
            lngMAX = objFS.Length - 1
            ReDim bytBUF(lngMAX)
            For lngIDX = 0 To lngMAX
                bytBUF(lngIDX) = objFS.ReadByte()
            Next
            objFS.Close()
            Return True
        Catch exERR As Exception
            Return False
        End Try
    End Function
    Function バイナリ書込(ByVal strNAM As String, ByVal bytBUF() As Byte, Optional ByVal lngPOS As Long = 0) As Boolean
        Dim objFS As System.IO.FileStream
        Dim lngMDE As System.IO.FileMode
        If lngPOS = 0 Then
            lngMDE = IO.FileMode.Create
        Else
            lngMDE = IO.FileMode.Open 'Append
        End If
        Try
            objFS = New System.IO.FileStream(strNAM, lngMDE, System.IO.FileAccess.Write)
            If lngPOS > 0 Then objFS.Position = lngPOS
            objFS.Write(bytBUF, 0, bytBUF.Length)
            objFS.Close()
            Return True
        Catch exERR As Exception
            Return False
        End Try
    End Function
    Function CHAR_BYTE(ByVal strBUF As String, Optional ByVal strCOD As String = strSJIS) As Byte()
        Dim objENC As System.Text.Encoding
        objENC = System.Text.Encoding.GetEncoding(strCOD)
        Return objENC.GetBytes(strBUF)
    End Function
    Function BYTE_CHAR(ByVal bytBUF As Byte(), Optional ByVal strCOD As String = strSJIS) As String
        Dim objENC As System.Text.Encoding
        If bytBUF Is Nothing Then Return ""
        objENC = System.Text.Encoding.GetEncoding(strCOD)
        Return objENC.GetString(bytBUF)
    End Function
    Function LenB(ByVal strWRD As String) As Integer
        Return System.Text.Encoding.GetEncoding(strSJIS).GetByteCount(strWRD)
    End Function
End Module
